---

# Parameters:
#   playbook inventory
#     stage := the name of the stage (e.g. dev, int, qa, prod)
#     tenant_id := (unique key for the tenant, e.g. customer)
#     cluster_name := (business name for the cluster, e.g. product, department )
#     cluster_size := (WIP node count for the cluster)
#     cluster_service := (service to setup, e.g. 'connect', ...)
#   smardigo message callback
#     scope_id := (scope id of the management process)
#     process_instance_id := (process instance id of the management process)
#     smardigo_management_action := (smardigo management action anme of the management process)

# Es wurde ein neues Playbook erstellt "remove_server", die für das löschen eines Servers zuständig ist.
# Es wurde eine Variable server_state initialisiert mir dem Defaultwert "present".
# Falls der Server gelöscht werden soll wird die variable in Playbook auf "absent" gesetzt
# Der Task "_set_server_state"  prüft den Status und fährt den Server runter oder hoch anhand dem Wert der variable "server_state"

#############################################################
#   Creating inventory dynamically for given parameters
#############################################################

- hosts: localhost
  gather_facts: false
  connection: local

  pre_tasks:
    - name: "Check if ansible version is at least 2.10.x"
      assert:
        that:
          - ansible_version.major >= 2
          - ansible_version.minor >= 10
        msg: "The ansible version has to be at least ({{ ansible_version.full }})"

#     add virtual server to load stage specific variables as context
    - name: "Add <{{ stage }}-virtual-host-to-read-groups-vars> to hosts"
      add_host:
        name: "{{ stage }}-virtual-host-to-read-groups-vars"
        groups:
        - "stage_{{ stage }}"
      changed_when: False

  tasks:
    - name: Add hosts
      add_host:
        name: "{{ stage }}-{{ tenant_id }}-{{ cluster_name }}-{{ '%02d' | format(item|int) }}"
        groups:
          - "stage_{{ stage }}"
          - "{{ cluster_service }}"
      with_sequence: start=1 end={{ cluster_size | default(1) }}
      changed_when: False
      when:
        - tenant_id is defined
        - cluster_name is defined
        - cluster_service is defined

#############################################################
#   Deleting servers/domains for created inventory
#############################################################

- hosts: "stage_{{ stage }}"
  serial: "{{ serial_number | default(5) }}"
  gather_facts: false

  tasks:
    - name: "Delete server <{{ inventory_hostname }}>"
      include_role:
        name: hcloud
        tasks_from: _set_server_state
      vars: 
        - server_state: "absent"

    - name: "Delete DNS entry <{{ inventory_hostname }}> for <{{ domain }}>"
      include_role:
        name: sma_digitalocean
        tasks_from: _remove_dns
      vars:
        record_to_remove: '{{ inventory_hostname }}'

#############################################################
#   Sending smardigo management message to process
#############################################################

- hosts: "{{ stage }}-virtual-host-to-read-groups-vars"
  serial: "{{ serial_number | default(1) }}"
  gather_facts: false
  connection: local
  run_once: true
  vars:
    connect_jwt_username: "{{ management_admin_username }}"

  tasks:
    - name: "Sending smardigo management message to <{{ smardigo_management_url }}>"
      include_tasks: tasks/smardigo_management_message.yml
